"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.fireDragDrop = fireDragDrop;
exports.fireDragHover = fireDragHover;
exports.fireDrag = fireDrag;
exports.fireReleaseDrag = fireReleaseDrag;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _vue = require("@testing-library/vue");
var _utils = require("./utils");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function fireDragDrop(source, target) {
    return _fireDragDrop.apply(this, arguments);
}
function _fireDragDrop() {
    _fireDragDrop = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(source, target) {
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    _ctx.next = 2;
                    return _vue.fireEvent.dragStart(source);
                case 2:
                    _ctx.next = 4;
                    return _vue.fireEvent.dragEnter(target);
                case 4:
                    _ctx.next = 6;
                    return _vue.fireEvent.dragOver(target);
                case 6:
                    _ctx.next = 8;
                    return _vue.fireEvent.drop(target);
                case 8:
                    _ctx.next = 10;
                    return (0, _utils).tick();
                case 10:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireDragDrop.apply(this, arguments);
}
function fireDragHover(source, target) {
    return _fireDragHover.apply(this, arguments);
}
function _fireDragHover() {
    _fireDragHover = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(source, target) {
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    _ctx.next = 2;
                    return _vue.fireEvent.dragStart(source);
                case 2:
                    _ctx.next = 4;
                    return _vue.fireEvent.dragEnter(target);
                case 4:
                    _ctx.next = 6;
                    return _vue.fireEvent.dragOver(target);
                case 6:
                    _ctx.next = 8;
                    return (0, _utils).tick();
                case 8:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireDragHover.apply(this, arguments);
}
function fireDrag(source) {
    return _fireDrag.apply(this, arguments);
}
function _fireDrag() {
    _fireDrag = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(source) {
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    _ctx.next = 2;
                    return _vue.fireEvent.dragStart(source);
                case 2:
                    _ctx.next = 4;
                    return (0, _utils).tick();
                case 4:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireDrag.apply(this, arguments);
}
function fireReleaseDrag() {
    return _fireReleaseDrag.apply(this, arguments);
}
function _fireReleaseDrag() {
    _fireReleaseDrag = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
        var container, _args = arguments;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    container = _args.length > 0 && _args[0] !== void 0 ? _args[0] : window;
                    _ctx.next = 3;
                    return _vue.fireEvent.drop(container);
                case 3:
                    _ctx.next = 5;
                    return (0, _utils).tick();
                case 5:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireReleaseDrag.apply(this, arguments);
}
