"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.wrapWithTestBackend = wrapWithTestBackend;
exports.wrapWithBackend = wrapWithBackend;
var _vue = require("vue");
var _reactDndTestBackend = require("react-dnd-test-backend");
var _reactDndHtml5Backend = require("react-dnd-html5-backend");
var _vue3Dnd = require("vue3-dnd");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function wrapWithTestBackend(DecoratedComponent, backendOptions) {
    var backend;
    var opts = Object.assign({
        onCreate: function onCreate(be) {
            backend = be;
        }
    }, backendOptions);
    var result = wrapWithBackend(DecoratedComponent, _reactDndTestBackend.TestBackend, opts);
    return [
        result,
        function() {
            return backend;
        }
    ];
}
function wrapWithBackend(DecoratedComponent) {
    var Backend = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : _reactDndHtml5Backend.HTML5Backend, backendOptions = arguments.length > 2 ? arguments[2] : void 0;
    return (0, _vue).defineComponent({
        render: function render() {
            var _this = this;
            return (0, _vue).h(_vue3Dnd.DndProvider, {
                backend: Backend,
                options: backendOptions
            }, {
                default: function() {
                    return (0, _vue).h(DecoratedComponent, _objectSpread({}, _this.$attrs));
                }
            });
        }
    });
}
