function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
import { wrapWithBackend } from "./wrappers";
import { render } from "@testing-library/vue";
import { HTML5Backend } from "react-dnd-html5-backend";
import { TestBackend } from "react-dnd-test-backend";
export function renderWithBackend(DecoratedComponent) {
    var renderOptions = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Backend = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : HTML5Backend, backendOptions = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {};
    var root = document.createElement("div");
    var WrappedWithBackend = wrapWithBackend(DecoratedComponent, Backend, _objectSpread({
        rootElement: root
    }, backendOptions));
    return render(WrappedWithBackend, _objectSpread({}, renderOptions, {
        container: root
    }));
}
export function renderWithTestBackend(DecoratedComponent) {
    var renderOptions = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, backendOptions = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
    return renderWithBackend(DecoratedComponent, renderOptions, TestBackend, backendOptions);
}
