function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
import regeneratorRuntime from "regenerator-runtime";
import { fireEvent } from "@testing-library/vue";
import { tick } from "./utils";
export function fireDragDrop(source, target) {
    return _fireDragDrop.apply(this, arguments);
}
function _fireDragDrop() {
    _fireDragDrop = _asyncToGenerator(regeneratorRuntime.mark(function _callee(source, target) {
        return regeneratorRuntime.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    _ctx.next = 2;
                    return fireEvent.dragStart(source);
                case 2:
                    _ctx.next = 4;
                    return fireEvent.dragEnter(target);
                case 4:
                    _ctx.next = 6;
                    return fireEvent.dragOver(target);
                case 6:
                    _ctx.next = 8;
                    return fireEvent.drop(target);
                case 8:
                    _ctx.next = 10;
                    return tick();
                case 10:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireDragDrop.apply(this, arguments);
}
export function fireDragHover(source, target) {
    return _fireDragHover.apply(this, arguments);
}
function _fireDragHover() {
    _fireDragHover = _asyncToGenerator(regeneratorRuntime.mark(function _callee(source, target) {
        return regeneratorRuntime.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    _ctx.next = 2;
                    return fireEvent.dragStart(source);
                case 2:
                    _ctx.next = 4;
                    return fireEvent.dragEnter(target);
                case 4:
                    _ctx.next = 6;
                    return fireEvent.dragOver(target);
                case 6:
                    _ctx.next = 8;
                    return tick();
                case 8:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireDragHover.apply(this, arguments);
}
export function fireDrag(source) {
    return _fireDrag.apply(this, arguments);
}
function _fireDrag() {
    _fireDrag = _asyncToGenerator(regeneratorRuntime.mark(function _callee(source) {
        return regeneratorRuntime.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    _ctx.next = 2;
                    return fireEvent.dragStart(source);
                case 2:
                    _ctx.next = 4;
                    return tick();
                case 4:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireDrag.apply(this, arguments);
}
export function fireReleaseDrag() {
    return _fireReleaseDrag.apply(this, arguments);
}
function _fireReleaseDrag() {
    _fireReleaseDrag = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
        var container, _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    container = _args.length > 0 && _args[0] !== void 0 ? _args[0] : window;
                    _ctx.next = 3;
                    return fireEvent.drop(container);
                case 3:
                    _ctx.next = 5;
                    return tick();
                case 5:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _fireReleaseDrag.apply(this, arguments);
}
